require 'nokogiri'
require 'open-uri'

require 'json'

class Struct
  def to_map
    map = Hash.new
    self.members.each { |m| map[m] = self[m] }
    map
  end

  def to_json(*a)
    to_map.to_json(*a)
  end
end

class Screencast < Struct.new(:title,:image,:number,:published_at,:comments_count); end

class Railscasts
  def self.screencasts
    url = 'http://railscasts.com/'
    doc = Nokogiri::HTML(open(URI url)) 
    num_pages = doc.css(".pagination a")[-2].text.to_i

    i = 0
    screencasts = [] 
    
    while i < num_pages do 
      i += 1 
      url = url.split('?')[0] + "?page=#{i}"
      p url 
      
      doc = Nokogiri::HTML(open(URI url)) 
      doc.css('.episode').each do |dom| 
        title = dom.css('.main h2 a').text
        image = dom.css('.screenshot img').first.attributes['src'].text
        number = dom.css('.number').text.split("Episode #")[-1]
        published_at = dom.css('.published_at').text
        comments_count = dom.css('.comments a').text.split(" ")[0]
        screencasts << Screencast.new(title,image,number,published_at,comments_count) 
      end 
    end 

    return screencasts.to_json
  end 
end 

